# Spotify Now Playing

## Description:

This module offers the ability to show your currently playing song on your website.

1. A JSON endpoint allows you to create this functionality yourself. A request to `/spotify_playing` will yield a cached JSON response identical to Spotify's currently playing API.
   2. Passing `reduce=1` will limit the data to only the items needed to render the custom block.
3. A custom block can be added to a region that will display a now playing widget.

This module facilitates talking to the Spotify API for you, but be warned, as with any third party API if you abuse your access you can get cut off without warning. Make sure to obey Spotify's terms of use regarding their APIs.

## Usage

First, create a developer account at https://developer.spotify.com/.

After installing the module on your site, navigate to the settings page. 

You will then create a new application on the Spotify developer site. You will mainly use the Web API. 

For the Redirect URI, that information is available on the settings page in Drupal.

Copy the client secret and client ID from your Spotify app into Drupal and save.

The JSON endpoint should now be available at `/spotify_playing`.

You can verify token information at `/spotify_playing/status`.

## Authors

Created by Ian Moffitt (https://www.drupal.org/u/nessthehero https://ianmoffitt.dev) for Drupal 10+.
